#include <malloc.h>
#include <string.h>
#include "RleOutStream.h"
#include "PtrMacro.h"

using namespace Framework;

CRleOutStream::CRleOutStream(FILE* pStream)
{
	if(pStream == NULL)
	{
		throw "Invalid file handle.";
	}

	m_pStream		= pStream;
	m_pBuffer		= (uint8*)malloc(BUFFERALLOCSIZE);
	m_nBufferSize	= 0;
}

CRleOutStream::~CRleOutStream()
{
	FlushBuffer();
	fclose(m_pStream);
	FREEPTR(m_pBuffer);
}

void CRleOutStream::FlushBuffer()
{
	uint8 nChar;
	uint8 nRun;
	unsigned int i, j;

	if(m_nBufferSize == 0) return;

	for(i = 0; i < m_nBufferSize; i++)
	{
		nChar = m_pBuffer[i];
		nRun = 1;

		for(j = i + 1; j < m_nBufferSize && nRun != 255; j++)
		{
			if(m_pBuffer[j] != nChar) break;
			i++;
			nRun++;
		}

		fwrite(&nRun, 1, 1, m_pStream);
		fwrite(&nChar, 1, 1, m_pStream);
	}

	m_nBufferSize = 0;
}

uint64 CRleOutStream::Read(void* pData, uint64 nSize)
{
	return 0;
}

uint64 CRleOutStream::Write(const void* pData, uint64 nSize)
{
	unsigned int nRest;
	uint64 nTotalSize;

	nTotalSize = nSize;

	while(1)
	{
		nRest = BUFFERALLOCSIZE - m_nBufferSize;
		
		if(nSize < nRest)
		{
			memcpy(m_pBuffer + m_nBufferSize, pData, (size_t)nSize);
			m_nBufferSize += (unsigned int)nSize;
			return nTotalSize;
		}

		//Copy the remains
		memcpy(m_pBuffer + m_nBufferSize, pData, nRest);

		pData = (const uint8*)pData + nRest;
		m_nBufferSize	+= nRest;
		nSize			-= nRest;

		FlushBuffer();
	}
}

void CRleOutStream::Seek(int64 nAmount, STREAM_SEEK_DIRECTION nPosition)
{

}

uint64 CRleOutStream::Tell()
{
	return 0;
}

bool CRleOutStream::IsEOF()
{
	return false;
}
