#include <string.h>
#include <malloc.h>
#include <assert.h>
#include "Str.h"
#include "PtrMacro.h"

using namespace Framework;

CStr::CStr(const char* sString)
{
	m_nSize = 0x20;
	m_pData = NULL;
	Load((char*)sString);
}

CStr::~CStr()
{
	FREEPTR(m_pData);
}

CStr& CStr::operator += (const char* sString)
{
	Append((char*)sString);
	return (*this);
}

CStr& CStr::operator += (char nChar)
{
	char sTemp[2];
	sTemp[0] = nChar;
	sTemp[1] = '\0';
	Append(sTemp);
	return (*this);
}

CStr& CStr::operator = (const char* sString)
{
	Load((char*)sString);
	return (*this);
}

CStr& CStr::operator = (const wchar_t* sString)
{
	assert(0);
	return (*this);
}

CStr::operator const char* ()
{
	return m_pData;
}

CStr::operator const wchar_t* ()
{
	assert(0);
	return NULL;
}

void CStr::Grow(unsigned int nRqSize)
{
	while(nRqSize > m_nSize)
	{
		m_nSize <<= 1;
	}
	m_pData = (char*)realloc(m_pData, m_nSize);
}

void CStr::Copy(char* sString, unsigned int nLenght)
{
	Grow(nLenght + 1);
	memcpy(m_pData, sString, nLenght);
	m_pData[nLenght] = '\0';
}

void CStr::Load(char* sString)
{
	unsigned int nLenght;
	nLenght = (unsigned int)strlen(sString);
	Grow(nLenght + 1);
	strcpy(m_pData, sString);
}

void CStr::Append(char* sString)
{
	unsigned int nLenght;
	nLenght = (unsigned int)strlen(sString) + (unsigned int)strlen(m_pData);
	Grow(nLenght + 1);
	strcat(m_pData, sString);
}
